Rem Midiplay.bas is the .mid player function for QB64 PD 2024.
Rem   v1.0a first release 05/02/2024
' declare variables.
Dim SoundHandle As Long
' enable midi support.
$Unstable:Midi
$MidiSoundFont:Default
' setup screen.
_Title "Midiplay"
_ScreenMove _Middle
' start midi interface.
Color 15
Print "Welcome to Midi player v1.0a."
Color 14
StartLoop:
Print "Enter midi file";
Input Midi$
If Midi$ = "" Then Color 7: End
Midi$ = UCase$(Midi$)
If Right$(Midi$, 4) <> ".MID" Then
   Print "File not found."
   GoTo StartLoop
End If
If _FileExists(Midi$) = 0 Then
   Print "File not found."
   GoTo StartLoop
End If
If Right$(Midi$, 4) = ".MID" Then
   If _FileExists(Midi$) Then
      Color 15
      Print "  Enter <space>=pause/+plus 10/-minus 10."
      Print "  Press <escape> to exit, <enter> to restart."
      Color 14
      '_SndPlayFile Midi$
      Print "Loading.."
      SoundHandle = _SndOpen(Midi$)
      If SoundHandle = 0 Then
         Print "File not found."
         GoTo StartLoop
      End If
      If SoundHandle Then
         Print "Playing.."
         _SndPlay SoundHandle
         Do
            _Limit 50
            x$ = InKey$
            If Len(x$) Then
               If x$ = Chr$(27) Then Exit Do
               If x$ = Chr$(13) Then
                  _SndStop SoundHandle
                  _SndClose sooundhandle
                  GoTo StartLoop
               End If
               If x$ = "+" Then
                  z! = _SndGetPos(SoundHandle)
                  z! = z! + 10!
                  _SndSetPos SoundHandle, z!
               End If
               If x$ = "-" Then
                  z! = _SndGetPos(SoundHandle)
                  z! = z! - 10!
                  If z! < 0! Then z! = 0!
                  _SndSetPos SoundHandle, z!
               End If
               If x$ = " " Then
                  If _SndPaused(SoundHandle) Then
                     Print "Resume play."
                     _SndPlay SoundHandle
                  Else
                     Print "Pause play."
                     _SndPause (SoundHandle)
                  End If
               End If
            End If
         Loop
      End If
   End If
End If
Color 7
End

